package ecd

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// CreateBandwidthResourcePackages invokes the ecd.CreateBandwidthResourcePackages API synchronously
func (client *Client) CreateBandwidthResourcePackages(request *CreateBandwidthResourcePackagesRequest) (response *CreateBandwidthResourcePackagesResponse, err error) {
	response = CreateCreateBandwidthResourcePackagesResponse()
	err = client.DoAction(request, response)
	return
}

// CreateBandwidthResourcePackagesWithChan invokes the ecd.CreateBandwidthResourcePackages API asynchronously
func (client *Client) CreateBandwidthResourcePackagesWithChan(request *CreateBandwidthResourcePackagesRequest) (<-chan *CreateBandwidthResourcePackagesResponse, <-chan error) {
	responseChan := make(chan *CreateBandwidthResourcePackagesResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.CreateBandwidthResourcePackages(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// CreateBandwidthResourcePackagesWithCallback invokes the ecd.CreateBandwidthResourcePackages API asynchronously
func (client *Client) CreateBandwidthResourcePackagesWithCallback(request *CreateBandwidthResourcePackagesRequest, callback func(response *CreateBandwidthResourcePackagesResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *CreateBandwidthResourcePackagesResponse
		var err error
		defer close(result)
		response, err = client.CreateBandwidthResourcePackages(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// CreateBandwidthResourcePackagesRequest is the request struct for api CreateBandwidthResourcePackages
type CreateBandwidthResourcePackagesRequest struct {
	*requests.RpcRequest
	Amount      requests.Integer `position:"Query" name:"Amount"`
	Period      requests.Integer `position:"Query" name:"Period"`
	AutoPay     requests.Boolean `position:"Query" name:"AutoPay"`
	PromotionId string           `position:"Query" name:"PromotionId"`
	PeriodUnit  string           `position:"Query" name:"PeriodUnit"`
	PackageSize requests.Integer `position:"Query" name:"PackageSize"`
}

// CreateBandwidthResourcePackagesResponse is the response struct for api CreateBandwidthResourcePackages
type CreateBandwidthResourcePackagesResponse struct {
	*responses.BaseResponse
	OrderId   int64  `json:"OrderId" xml:"OrderId"`
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateCreateBandwidthResourcePackagesRequest creates a request to invoke CreateBandwidthResourcePackages API
func CreateCreateBandwidthResourcePackagesRequest() (request *CreateBandwidthResourcePackagesRequest) {
	request = &CreateBandwidthResourcePackagesRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("ecd", "2020-09-30", "CreateBandwidthResourcePackages", "", "")
	request.Method = requests.POST
	return
}

// CreateCreateBandwidthResourcePackagesResponse creates a response to parse from CreateBandwidthResourcePackages response
func CreateCreateBandwidthResourcePackagesResponse() (response *CreateBandwidthResourcePackagesResponse) {
	response = &CreateBandwidthResourcePackagesResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
