package ecd

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DeleteUserTags invokes the ecd.DeleteUserTags API synchronously
func (client *Client) DeleteUserTags(request *DeleteUserTagsRequest) (response *DeleteUserTagsResponse, err error) {
	response = CreateDeleteUserTagsResponse()
	err = client.DoAction(request, response)
	return
}

// DeleteUserTagsWithChan invokes the ecd.DeleteUserTags API asynchronously
func (client *Client) DeleteUserTagsWithChan(request *DeleteUserTagsRequest) (<-chan *DeleteUserTagsResponse, <-chan error) {
	responseChan := make(chan *DeleteUserTagsResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DeleteUserTags(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DeleteUserTagsWithCallback invokes the ecd.DeleteUserTags API asynchronously
func (client *Client) DeleteUserTagsWithCallback(request *DeleteUserTagsRequest, callback func(response *DeleteUserTagsResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DeleteUserTagsResponse
		var err error
		defer close(result)
		response, err = client.DeleteUserTags(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DeleteUserTagsRequest is the request struct for api DeleteUserTags
type DeleteUserTagsRequest struct {
	*requests.RpcRequest
	Tags *[]string `position:"Query" name:"Tags"  type:"Repeated"`
}

// DeleteUserTagsResponse is the response struct for api DeleteUserTags
type DeleteUserTagsResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateDeleteUserTagsRequest creates a request to invoke DeleteUserTags API
func CreateDeleteUserTagsRequest() (request *DeleteUserTagsRequest) {
	request = &DeleteUserTagsRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("ecd", "2020-09-30", "DeleteUserTags", "", "")
	request.Method = requests.POST
	return
}

// CreateDeleteUserTagsResponse creates a response to parse from DeleteUserTags response
func CreateDeleteUserTagsResponse() (response *DeleteUserTagsResponse) {
	response = &DeleteUserTagsResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
