package ecd

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeHardwareTerminals invokes the ecd.DescribeHardwareTerminals API synchronously
func (client *Client) DescribeHardwareTerminals(request *DescribeHardwareTerminalsRequest) (response *DescribeHardwareTerminalsResponse, err error) {
	response = CreateDescribeHardwareTerminalsResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeHardwareTerminalsWithChan invokes the ecd.DescribeHardwareTerminals API asynchronously
func (client *Client) DescribeHardwareTerminalsWithChan(request *DescribeHardwareTerminalsRequest) (<-chan *DescribeHardwareTerminalsResponse, <-chan error) {
	responseChan := make(chan *DescribeHardwareTerminalsResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeHardwareTerminals(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeHardwareTerminalsWithCallback invokes the ecd.DescribeHardwareTerminals API asynchronously
func (client *Client) DescribeHardwareTerminalsWithCallback(request *DescribeHardwareTerminalsRequest, callback func(response *DescribeHardwareTerminalsResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeHardwareTerminalsResponse
		var err error
		defer close(result)
		response, err = client.DescribeHardwareTerminals(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeHardwareTerminalsRequest is the request struct for api DescribeHardwareTerminals
type DescribeHardwareTerminalsRequest struct {
	*requests.RpcRequest
	HardwareVersion string `position:"Query" name:"HardwareVersion"`
	HardwareType    string `position:"Query" name:"HardwareType"`
}

// DescribeHardwareTerminalsResponse is the response struct for api DescribeHardwareTerminals
type DescribeHardwareTerminalsResponse struct {
	*responses.BaseResponse
	RequestId         string             `json:"RequestId" xml:"RequestId"`
	HardwareTerminals []HardwareTerminal `json:"HardwareTerminals" xml:"HardwareTerminals"`
}

// CreateDescribeHardwareTerminalsRequest creates a request to invoke DescribeHardwareTerminals API
func CreateDescribeHardwareTerminalsRequest() (request *DescribeHardwareTerminalsRequest) {
	request = &DescribeHardwareTerminalsRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("ecd", "2020-09-30", "DescribeHardwareTerminals", "", "")
	request.Method = requests.POST
	return
}

// CreateDescribeHardwareTerminalsResponse creates a response to parse from DescribeHardwareTerminals response
func CreateDescribeHardwareTerminalsResponse() (response *DescribeHardwareTerminalsResponse) {
	response = &DescribeHardwareTerminalsResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
