package ecd

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ModifyNetworkPackage invokes the ecd.ModifyNetworkPackage API synchronously
func (client *Client) ModifyNetworkPackage(request *ModifyNetworkPackageRequest) (response *ModifyNetworkPackageResponse, err error) {
	response = CreateModifyNetworkPackageResponse()
	err = client.DoAction(request, response)
	return
}

// ModifyNetworkPackageWithChan invokes the ecd.ModifyNetworkPackage API asynchronously
func (client *Client) ModifyNetworkPackageWithChan(request *ModifyNetworkPackageRequest) (<-chan *ModifyNetworkPackageResponse, <-chan error) {
	responseChan := make(chan *ModifyNetworkPackageResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ModifyNetworkPackage(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ModifyNetworkPackageWithCallback invokes the ecd.ModifyNetworkPackage API asynchronously
func (client *Client) ModifyNetworkPackageWithCallback(request *ModifyNetworkPackageRequest, callback func(response *ModifyNetworkPackageResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ModifyNetworkPackageResponse
		var err error
		defer close(result)
		response, err = client.ModifyNetworkPackage(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ModifyNetworkPackageRequest is the request struct for api ModifyNetworkPackage
type ModifyNetworkPackageRequest struct {
	*requests.RpcRequest
	Bandwidth        requests.Integer `position:"Query" name:"Bandwidth"`
	NetworkPackageId string           `position:"Query" name:"NetworkPackageId"`
}

// ModifyNetworkPackageResponse is the response struct for api ModifyNetworkPackage
type ModifyNetworkPackageResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateModifyNetworkPackageRequest creates a request to invoke ModifyNetworkPackage API
func CreateModifyNetworkPackageRequest() (request *ModifyNetworkPackageRequest) {
	request = &ModifyNetworkPackageRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("ecd", "2020-09-30", "ModifyNetworkPackage", "", "")
	request.Method = requests.POST
	return
}

// CreateModifyNetworkPackageResponse creates a response to parse from ModifyNetworkPackage response
func CreateModifyNetworkPackageResponse() (response *ModifyNetworkPackageResponse) {
	response = &ModifyNetworkPackageResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
