package voicenavigator

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// BatchCreateSandBoxWhileList invokes the voicenavigator.BatchCreateSandBoxWhileList API synchronously
func (client *Client) BatchCreateSandBoxWhileList(request *BatchCreateSandBoxWhileListRequest) (response *BatchCreateSandBoxWhileListResponse, err error) {
	response = CreateBatchCreateSandBoxWhileListResponse()
	err = client.DoAction(request, response)
	return
}

// BatchCreateSandBoxWhileListWithChan invokes the voicenavigator.BatchCreateSandBoxWhileList API asynchronously
func (client *Client) BatchCreateSandBoxWhileListWithChan(request *BatchCreateSandBoxWhileListRequest) (<-chan *BatchCreateSandBoxWhileListResponse, <-chan error) {
	responseChan := make(chan *BatchCreateSandBoxWhileListResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.BatchCreateSandBoxWhileList(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// BatchCreateSandBoxWhileListWithCallback invokes the voicenavigator.BatchCreateSandBoxWhileList API asynchronously
func (client *Client) BatchCreateSandBoxWhileListWithCallback(request *BatchCreateSandBoxWhileListRequest, callback func(response *BatchCreateSandBoxWhileListResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *BatchCreateSandBoxWhileListResponse
		var err error
		defer close(result)
		response, err = client.BatchCreateSandBoxWhileList(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// BatchCreateSandBoxWhileListRequest is the request struct for api BatchCreateSandBoxWhileList
type BatchCreateSandBoxWhileListRequest struct {
	*requests.RpcRequest
	WhiteListJson string `position:"Query" name:"WhiteListJson"`
}

// BatchCreateSandBoxWhileListResponse is the response struct for api BatchCreateSandBoxWhileList
type BatchCreateSandBoxWhileListResponse struct {
	*responses.BaseResponse
	RequestId string          `json:"RequestId" xml:"RequestId"`
	Repeat    bool            `json:"Repeat" xml:"Repeat"`
	WhiteList []WhiteListItem `json:"WhiteList" xml:"WhiteList"`
}

// CreateBatchCreateSandBoxWhileListRequest creates a request to invoke BatchCreateSandBoxWhileList API
func CreateBatchCreateSandBoxWhileListRequest() (request *BatchCreateSandBoxWhileListRequest) {
	request = &BatchCreateSandBoxWhileListRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("VoiceNavigator", "2018-06-12", "BatchCreateSandBoxWhileList", "voicebot", "openAPI")
	request.Method = requests.POST
	return
}

// CreateBatchCreateSandBoxWhileListResponse creates a response to parse from BatchCreateSandBoxWhileList response
func CreateBatchCreateSandBoxWhileListResponse() (response *BatchCreateSandBoxWhileListResponse) {
	response = &BatchCreateSandBoxWhileListResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
