package voicenavigator

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DeleteSandBoxWhileList invokes the voicenavigator.DeleteSandBoxWhileList API synchronously
func (client *Client) DeleteSandBoxWhileList(request *DeleteSandBoxWhileListRequest) (response *DeleteSandBoxWhileListResponse, err error) {
	response = CreateDeleteSandBoxWhileListResponse()
	err = client.DoAction(request, response)
	return
}

// DeleteSandBoxWhileListWithChan invokes the voicenavigator.DeleteSandBoxWhileList API asynchronously
func (client *Client) DeleteSandBoxWhileListWithChan(request *DeleteSandBoxWhileListRequest) (<-chan *DeleteSandBoxWhileListResponse, <-chan error) {
	responseChan := make(chan *DeleteSandBoxWhileListResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DeleteSandBoxWhileList(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DeleteSandBoxWhileListWithCallback invokes the voicenavigator.DeleteSandBoxWhileList API asynchronously
func (client *Client) DeleteSandBoxWhileListWithCallback(request *DeleteSandBoxWhileListRequest, callback func(response *DeleteSandBoxWhileListResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DeleteSandBoxWhileListResponse
		var err error
		defer close(result)
		response, err = client.DeleteSandBoxWhileList(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DeleteSandBoxWhileListRequest is the request struct for api DeleteSandBoxWhileList
type DeleteSandBoxWhileListRequest struct {
	*requests.RpcRequest
	PhoneNumber string `position:"Query" name:"PhoneNumber"`
	InstanceId  string `position:"Query" name:"InstanceId"`
}

// DeleteSandBoxWhileListResponse is the response struct for api DeleteSandBoxWhileList
type DeleteSandBoxWhileListResponse struct {
	*responses.BaseResponse
	Uuid        string `json:"Uuid" xml:"Uuid"`
	RequestId   string `json:"RequestId" xml:"RequestId"`
	PhoneNumber string `json:"PhoneNumber" xml:"PhoneNumber"`
}

// CreateDeleteSandBoxWhileListRequest creates a request to invoke DeleteSandBoxWhileList API
func CreateDeleteSandBoxWhileListRequest() (request *DeleteSandBoxWhileListRequest) {
	request = &DeleteSandBoxWhileListRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("VoiceNavigator", "2018-06-12", "DeleteSandBoxWhileList", "voicebot", "openAPI")
	request.Method = requests.POST
	return
}

// CreateDeleteSandBoxWhileListResponse creates a response to parse from DeleteSandBoxWhileList response
func CreateDeleteSandBoxWhileListResponse() (response *DeleteSandBoxWhileListResponse) {
	response = &DeleteSandBoxWhileListResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
